package data.scripts.world.systems;

import com.fs.starfarer.api.campaign.CampaignFleetAPI;
import com.fs.starfarer.api.campaign.FleetAssignment;
import com.fs.starfarer.api.campaign.LocationAPI;
import com.fs.starfarer.api.campaign.SectorAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;
import com.fs.starfarer.api.campaign.StarSystemAPI;

import data.scripts.world.BaseSpawnPoint;

@SuppressWarnings("unchecked")
public class DiktatPatrolSpawnPoint extends BaseSpawnPoint {

	 public DiktatPatrolSpawnPoint(SectorAPI sector, LocationAPI location, 
									float daysInterval, int maxFleets, SectorEntityToken anchor) {
		super(sector, location, daysInterval, maxFleets, anchor);
	}

	
	@Override
	public CampaignFleetAPI spawnFleet() {
		//if ((float) Math.random() < 0.75f) return null;
		String type = "patrol";
		if ((float) Math.random() < 0.25f) {
			type = "guard";
		}
		
		float angle = (float) ((float) Math.random() * Math.PI * 2f);
		float x = (float) (Math.cos(angle) * 12000f);
		float y = (float) (Math.sin(angle) * 12000f);
		SectorEntityToken spawnPoint = getLocation().createToken(x, y);
		
		
		CampaignFleetAPI fleet = getSector().createFleet("sindrian_diktat", type);
		getLocation().spawnFleet(spawnPoint, 0, 0, fleet);
		fleet.setPreferredResupplyLocation(getAnchor());

		if ((float) Math.random() > 0.75f) {
			fleet.addAssignment(FleetAssignment.PATROL_SYSTEM, ((StarSystemAPI)getLocation()).getHyperspaceAnchor(), 30);
			fleet.addAssignment(FleetAssignment.GO_TO_LOCATION_AND_DESPAWN, getAnchor(), 1000);
		} else {
			fleet.addAssignment(FleetAssignment.PATROL_SYSTEM, null, 60);
			fleet.addAssignment(FleetAssignment.GO_TO_LOCATION_AND_DESPAWN, spawnPoint, 1000);
		}
		
		return fleet;
	}
	
}






